'use client';
import IconDownload from '@/components/icon/icon-download';
import IconEye from '@/components/icon/icon-eye';
import IconSave from '@/components/icon/icon-save';
import IconSend from '@/components/icon/icon-send';
import IconX from '@/components/icon/icon-x';
import Link from 'next/link';
import React, { useState } from 'react';

export default function() {
    const currencyList = ['ريال'];

    const [items, setItems] = useState<any>([
        {
            id: 1,
            title: '',
            description: '',
            rate: 0,
            quantity: 0,
            amount: 0,
        },
    ]);

    const addItem = () => {
        let maxId = 0;
        maxId = items?.length ? items.reduce((max: number, character: any) => (character.id > max ? character.id : max), items[0].id) : 0;

        setItems([
            ...items,
            {
                id: maxId + 1,
                title: '',
                description: '',
                rate: 0,
                quantity: 0,
                amount: 0,
            },
        ]);
    };

    const removeItem = (item: any = null) => {
        setItems(items.filter((d: any) => d.id !== item.id));
    };

    const changeQuantityPrice = (type: string, value: string, id: number) => {
        const list = items;
        const item = list.find((d: any) => d.id === id);
        if (type === 'quantity') {
            item.quantity = Number(value);
        }
        if (type === 'price') {
            item.amount = Number(value);
        }
        setItems([...list]);
    };

    return (
        <div className="flex flex-col gap-2.5 xl:flex-row">
            <div className="panel flex-1 px-0 py-6 ltr:xl:mr-6 rtl:xl:ml-6">
                <div className="flex flex-wrap justify-between px-4">
                    <div className="mb-6 w-full lg:w-1/2">
                        <div className="flex shrink-0 items-center text-black dark:text-white">
                            <img src="/assets/images/logo.png" alt="img" className="w-28" />
                        </div>
                        <div className="mt-6 space-y-1 text-gray-500 dark:text-gray-400">
                            <div>البرز - خ البرز - محله البرز</div>
                            <div>vristo@gmail.com</div>
                            <div>09105969906</div>
                        </div>
                    </div>
                    <div className="w-full lg:w-1/2 lg:max-w-fit">
                        <div className="flex items-center">
                            <label htmlFor="number" className="mb-0 flex-1 ltr:mr-2 rtl:ml-2">
                                شماره فاکتور
                            </label>
                            <input id="number" type="text" name="inv-num" className="form-input w-2/3 lg:w-[250px]" placeholder="شماره فاکتور" />
                        </div>
                        <div className="mt-4 flex items-center">
                            <label htmlFor="invoiceLabel" className="mb-0 flex-1 ltr:mr-2 rtl:ml-2">
                                توضیحات فاکتور
                            </label>
                            <input id="invoiceLabel" type="text" name="inv-label" className="form-input w-2/3 lg:w-[250px]" placeholder="توضیحات فاکتور" />
                        </div>
                        <div className="mt-4 flex items-center">
                            <label htmlFor="startDate" className="mb-0 flex-1 ltr:mr-2 rtl:ml-2">
                                تاریخ فاکتور
                            </label>
                            <input id="startDate" type="date" name="inv-date" className="form-input w-2/3 lg:w-[250px]" />
                        </div>
                        <div className="mt-4 flex items-center">
                            <label htmlFor="dueDate" className="mb-0 flex-1 ltr:mr-2 rtl:ml-2">
                                سررسید
                            </label>
                            <input id="dueDate" type="date" name="due-date" className="form-input w-2/3 lg:w-[250px]" />
                        </div>
                    </div>
                </div>
                <hr className="my-6 border-white-light dark:border-[#1b2e4b]" />
                <div className="mt-8 px-4">
                    <div className="flex flex-col justify-between lg:flex-row">
                        <div className="mb-6 w-full lg:w-1/2 ltr:lg:mr-6 rtl:lg:ml-6">
                            <div className="text-lg">صورت حساب :-</div>
                            <div className="mt-4 flex items-center">
                                <label htmlFor="reciever-name" className="mb-0 w-1/3 ltr:mr-2 rtl:ml-2">
                                    نام و نام خانوادگی
                                </label>
                                <input id="reciever-name" type="text" name="reciever-name" className="form-input flex-1" placeholder="نام" />
                            </div>
                            <div className="mt-4 flex items-center">
                                <label htmlFor="reciever-email" className="mb-0 w-1/3 ltr:mr-2 rtl:ml-2">
                                    ایمیل
                                </label>
                                <input id="reciever-email" type="email" name="reciever-email" className="form-input flex-1" placeholder="ایمیل" />
                            </div>
                            <div className="mt-4 flex items-center">
                                <label htmlFor="reciever-address" className="mb-0 w-1/3 ltr:mr-2 rtl:ml-2">
                                    نشانی پستی
                                </label>
                                <input id="reciever-address" type="text" name="reciever-address" className="form-input flex-1" placeholder="نشانی" />
                            </div>
                            <div className="mt-4 flex items-center">
                                <label htmlFor="reciever-number" className="mb-0 w-1/3 ltr:mr-2 rtl:ml-2">
                                    شماره همراه
                                </label>
                                <input id="reciever-number" type="text" name="reciever-number" className="form-input flex-1" placeholder="0910" />
                            </div>
                        </div>
                        <div className="w-full lg:w-1/2">
                            <div className="text-lg">جزییات پرداخت:</div>
                            <div className="mt-4 flex items-center">
                                <label htmlFor="acno" className="mb-0 w-1/3 ltr:mr-2 rtl:ml-2">
                                    شماره مشتری
                                </label>
                                <input id="acno" type="text" name="acno" className="form-input flex-1" placeholder="شماره مشتری" />
                            </div>
                            <div className="mt-4 flex items-center">
                                <label htmlFor="bank-name" className="mb-0 w-1/3 ltr:mr-2 rtl:ml-2">
                                    بانک
                                </label>
                                <input id="bank-name" type="text" name="bank-name" className="form-input flex-1" placeholder="بانک" />
                            </div>
                            <div className="mt-4 flex items-center">
                                <label htmlFor="swift-code" className="mb-0 w-1/3 ltr:mr-2 rtl:ml-2">
                                    شماره کارت
                                </label>
                                <input id="swift-code" type="text" name="swift-code" className="form-input flex-1" placeholder="شماره کارت" />
                            </div>
                            <div className="mt-4 flex items-center">
                                <label htmlFor="iban-code" className="mb-0 w-1/3 ltr:mr-2 rtl:ml-2">
                                    شماره شبا
                                </label>
                                <input id="iban-code" type="text" name="iban-code" className="form-input flex-1" placeholder="شماره شبا" />
                            </div>

                        </div>
                    </div>
                </div>
                <div className="mt-8">
                    <div className="table-responsive">
                        <table>
                            <thead>
                            <tr>
                                <th>ردیف</th>
                                <th className="w-1">تعداد</th>
                                <th className="w-1">قیمت</th>
                                <th>جمع</th>
                                <th className="w-1"></th>
                            </tr>
                            </thead>
                            <tbody>
                            {items.length <= 0 && (
                                <tr>
                                    <td colSpan={5} className="!text-center font-semibold">
                                        No Item Available
                                    </td>
                                </tr>
                            )}
                            {items.map((item: any) => {
                                return (
                                    <tr className="align-top" key={item.id}>
                                        <td>
                                            <input type="text" className="form-input min-w-[200px]" placeholder="نام مورد را وارد کنید" defaultValue={item.title} />
                                            <textarea className="form-textarea mt-4" placeholder="توضیحات را وارد کنید" defaultValue={item.description}></textarea>
                                        </td>
                                        <td>
                                            <input
                                                type="number"
                                                className="form-input w-32"
                                                placeholder="Quantity"
                                                defaultValue={item.quantity}
                                                min={0}
                                                onChange={(e) => changeQuantityPrice('quantity', e.target.value, item.id)}
                                            />
                                        </td>
                                        <td>
                                            <input
                                                type="number"
                                                className="form-input w-32"
                                                placeholder="Price"
                                                defaultValue={item.amount}
                                                min={0}
                                                onChange={(e) => changeQuantityPrice('price', e.target.value, item.id)}
                                            />
                                        </td>
                                        <td>${item.quantity * item.amount}</td>
                                        <td>
                                            <button type="button" onClick={() => removeItem(item)}>
                                                <IconX className="h-5 w-5" />
                                            </button>
                                        </td>
                                    </tr>
                                );
                            })}
                            </tbody>
                        </table>
                    </div>
                    <div className="mt-6 flex flex-col justify-between px-4 sm:flex-row">
                        <div className="mb-6 sm:mb-0">
                            <button type="button" className="btn btn-primary" onClick={() => addItem()}>
                                اضافه کردن ردیف
                            </button>
                        </div>
                        <div className="sm:w-2/5">
                            <div className="flex items-center justify-between">
                                <div>جمع</div>
                                <div>$0.00</div>
                            </div>
                            <div className="mt-4 flex items-center justify-between">
                                <div>مالیات(%)</div>
                                <div>0%</div>
                            </div>
                            <div className="mt-4 flex items-center justify-between">
                                <div>هزینه حمل و نقل($)</div>
                                <div>$0.00</div>
                            </div>
                            <div className="mt-4 flex items-center justify-between">
                                <div>تخفیف(%)</div>
                                <div>0%</div>
                            </div>
                            <div className="mt-4 flex items-center justify-between font-semibold">
                                <div>جمع پرداختی</div>
                                <div>$0.00</div>
                            </div>
                        </div>
                    </div>
                </div>
                <div className="mt-8 px-4">
                    <label htmlFor="notes">توضیحات</label>
                    <textarea id="notes" name="notes" className="form-textarea min-h-[130px]" placeholder="توضیحات"></textarea>
                </div>
            </div>
            <div className="mt-6 w-full xl:mt-0 xl:w-96">
                <div className="panel mb-5">
                    <label htmlFor="currency">واحد پولی</label>
                    <select id="currency" name="currency" className="form-select">
                        {currencyList.map((i) => (
                            <option key={i}>{i}</option>
                        ))}
                    </select>
                    <div className="mt-4">
                        <div className="grid grid-cols-1 gap-4 sm:grid-cols-2">
                            <div>
                                <label htmlFor="tax">مالیات(%) </label>
                                <input id="tax" type="number" name="tax" className="form-input" defaultValue={0} placeholder="Tax" />
                            </div>
                            <div>
                                <label htmlFor="discount">تخفیف(%) </label>
                                <input id="discount" type="number" name="discount" className="form-input" defaultValue={0} placeholder="Discount" />
                            </div>
                        </div>
                    </div>
                    <div className="mt-4">
                        <div>
                            <label htmlFor="shipping-charge">هزینه حمل و نقل($) </label>
                            <input id="shipping-charge" type="number" name="shipping-charge" className="form-input" defaultValue={0} placeholder="Shipping Charge" />
                        </div>
                    </div>
                    <div className="mt-4">
                        <label htmlFor="payment-method">پذیرش پرداخت از طریق</label>
                        <select id="payment-method" name="payment-method" className="form-select">
                            <option value=" ">پرداخت را انتخاب کنید</option>
                            <option value="bank">ملت</option>
                            <option value="paypal">صادرات</option>
                            <option value="upi">ملی</option>
                        </select>
                    </div>
                </div>
                <div className="panel">
                    <div className="grid grid-cols-1 gap-4 sm:grid-cols-2 lg:grid-cols-4 xl:grid-cols-1">
                        <button type="button" className="btn btn-success w-full gap-2">
                            <IconSave className="shrink-0 ltr:mr-2 rtl:ml-2" />
                            ذخیره
                        </button>

                        <button type="button" className="btn btn-info w-full gap-2">
                            <IconSend className="shrink-0 ltr:mr-2 rtl:ml-2" />
                            ارسال فاکتور
                        </button>

                        <Link href="/apps/invoice/preview" className="btn btn-primary w-full gap-2">
                            <IconEye className="shrink-0 ltr:mr-2 rtl:ml-2" />
                            نمایش
                        </Link>

                        <button type="button" className="btn btn-secondary w-full gap-2">
                            <IconDownload className="shrink-0 ltr:mr-2 rtl:ml-2" />
                            دانلود
                        </button>
                    </div>
                </div>
            </div>
        </div>
    );
}
